<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZ: scripts/4_World/Entities/Firearms/FSM/States/WeaponStateBase.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZ<span id="projectnumber">&#160;1.18.155069</span>
   </div>
   <div id="projectbrief">DayZ Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d3/d28/_weapon_state_base_8c_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">WeaponStateBase.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d3/d28/_weapon_state_base_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span> </div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="keyword">class </span><a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span>{</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">   12</a></span>    <a class="code hl_class" href="../../d3/d9c/class_weapon___base.html">Weapon_Base</a> <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a>; </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a5c32e0d708fb55e89cf3d5c8467b8171">   13</a></span>    <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a5c32e0d708fb55e89cf3d5c8467b8171">m_parentState</a>; </div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">   14</a></span>    ref <a class="code hl_class" href="../../d0/deb/namespace_3global_scope_4.html#dc/d73/class_weapon_f_s_m">WeaponFSM</a> <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>; </div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#abf96f46d474286b755b35c5d6e7f1a5d">   15</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#abf96f46d474286b755b35c5d6e7f1a5d">m_InternalID</a> = -1; </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span> </div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a3d9777a692f1e7eed3fe85701530a0f6">   17</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a3d9777a692f1e7eed3fe85701530a0f6">WeaponStateBase</a> (<a class="code hl_class" href="../../d3/d9c/class_weapon___base.html">Weapon_Base</a> w = NULL, <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> parent = NULL) { <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a> = w; <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a5c32e0d708fb55e89cf3d5c8467b8171">m_parentState</a> = parent; }</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span> </div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a989ec0b0f612e282fc36b006dd2eb9a4">   22</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a989ec0b0f612e282fc36b006dd2eb9a4">SetParentState</a> (<a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> parent) { <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a5c32e0d708fb55e89cf3d5c8467b8171">m_parentState</a> = parent; }</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#abb1ef39a577289abdc0dcd6f422873fe">   26</a></span>    <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#abb1ef39a577289abdc0dcd6f422873fe">GetParentState</a> () { <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a5c32e0d708fb55e89cf3d5c8467b8171">m_parentState</a>; }</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a3a7c890c185e21f88cad7981bd237bbf">   28</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a3a7c890c185e21f88cad7981bd237bbf">HasFSM</a> () { <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a> != NULL; }</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a21817665ec759d08ee0c575ba325fd79">   29</a></span>    <a class="code hl_class" href="../../d0/deb/namespace_3global_scope_4.html#dc/d73/class_weapon_f_s_m">WeaponFSM</a> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a21817665ec759d08ee0c575ba325fd79">GetFSM</a> () { <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>; }</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#acf59c5609264e2cfc2eaed43bb116a53">   31</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#acf59c5609264e2cfc2eaed43bb116a53">SetInternalStateID</a> (<span class="keywordtype">int</span> i) { <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#abf96f46d474286b755b35c5d6e7f1a5d">m_InternalID</a> = i; }</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a4ece586a64173d7526e0c4997d97f214">   32</a></span>    <span class="keywordtype">int</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a4ece586a64173d7526e0c4997d97f214">GetInternalStateID</a> () { <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#abf96f46d474286b755b35c5d6e7f1a5d">m_InternalID</a>; }</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span> </div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a00cd223c25fd599bd32da48bbbb40eac">   34</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a00cd223c25fd599bd32da48bbbb40eac">SaveCurrentFSMState</a> (<a class="code hl_class" href="../../d0/dc2/class_serializer.html">ParamsWriteContext</a> ctx)</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    {</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a3a7c890c185e21f88cad7981bd237bbf">HasFSM</a>())</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>        {</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>            <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a2c0638897b587a6c5b068ed02baf0ce6">IsIdle</a>())</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>            {</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>                <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#acea538bf7a4dc05b05c22218a83bee44">wpnDebugSpam</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a>) + <span class="stringliteral">&quot; WeaponStateBase::SaveCurrentFSMState - idle state, skipping other substates&quot;</span>); }</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>                <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.SaveCurrentFSMState(ctx);</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>            }</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>            <span class="keywordflow">else</span></div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>            {</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>                <span class="comment">// if parent state is !idle (unstable) then save whole machine</span></div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>                <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#acea538bf7a4dc05b05c22218a83bee44">wpnDebugSpam</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a>) + <span class="stringliteral">&quot; WeaponStateBase::SaveCurrentFSMState - NOT idle state, saving full submachine state&quot;</span>); }</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>                <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.SaveCurrentUnstableFSMState(ctx);</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>            }</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>        }</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>    }</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span> </div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a5db3e9a07c531a470a5b80bca596c3e8">   54</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a5db3e9a07c531a470a5b80bca596c3e8">LoadCurrentFSMState</a> (<a class="code hl_class" href="../../d0/dc2/class_serializer.html">ParamsReadContext</a> ctx, <span class="keywordtype">int</span> version)</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>    {</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a3a7c890c185e21f88cad7981bd237bbf">HasFSM</a>())</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>        {</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>            <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a2c0638897b587a6c5b068ed02baf0ce6">IsIdle</a>())</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>            {</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>                <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#acea538bf7a4dc05b05c22218a83bee44">wpnDebugSpam</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a>) + <span class="stringliteral">&quot; WeaponStateBase::LoadCurrentFSMState - idle state, skipping other substates&quot;</span>); }</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>                <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.LoadCurrentFSMState(ctx, version))</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>                    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>                <span class="keywordflow">else</span></div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>                    <a class="code hl_function" href="../../d0/d62/group___debug.html#ga786b160dafbe15abb829786ba345cb15">Error</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a>) + <span class="stringliteral">&quot; WeaponStateBase::LoadCurrentFSMState - Cannot load stable state for weapon=&quot;</span> + <span class="keyword">this</span>);</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>            }</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>            <span class="keywordflow">else</span></div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>            {</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>                <span class="comment">// if parent state is !idle (unstable) then load whole machine</span></div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>                <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#acea538bf7a4dc05b05c22218a83bee44">wpnDebugSpam</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a>) + <span class="stringliteral">&quot; WeaponStateBase::LoadCurrentFSMState - NOT idle state, loading full submachine state&quot;</span>); }</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>                <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.LoadCurrentUnstableFSMState(ctx, version))</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>                    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>                <span class="keywordflow">else</span></div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>                    <a class="code hl_function" href="../../d0/d62/group___debug.html#ga786b160dafbe15abb829786ba345cb15">Error</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a>) + <span class="stringliteral">&quot; WeaponStateBase::LoadCurrentFSMState - Cannot load unstable state for weapon=&quot;</span> + <span class="keyword">this</span>);</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>            }</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>        }</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>    }</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span> </div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a033f970fce594c972f001f982a5c153f">   80</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a033f970fce594c972f001f982a5c153f">ProcessEvent</a> (<a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e)</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>    {</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a3a7c890c185e21f88cad7981bd237bbf">HasFSM</a>())</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>            <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.ProcessEvent(e);</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>    }</div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#ad21398c2a10afb8fae352b527bdbd9f3">   89</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#ad21398c2a10afb8fae352b527bdbd9f3">AddTransition</a> (<a class="code hl_typedef" href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a> t)</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>    {</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a3a7c890c185e21f88cad7981bd237bbf">HasFSM</a>())</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>            <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.AddTransition(t);</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>            <a class="code hl_function" href="../../d0/d62/group___debug.html#ga786b160dafbe15abb829786ba345cb15">Error</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a>) + <span class="stringliteral">&quot; adding transition to state without FSM. Configure FSM first.&quot;</span>);</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>    }</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span> </div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span> </div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#af630f354d30ca508c6d778a91b841098">  103</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#af630f354d30ca508c6d778a91b841098">OnEntry</a> (<a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e)</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>    {</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a3a7c890c185e21f88cad7981bd237bbf">HasFSM</a>() &amp;&amp; !<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.IsRunning())</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        {</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>            <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#afa33033805ea8cbc9b91ae2d002ffcd7">wpnDebugPrint</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a>) + <span class="stringliteral">&quot; { &quot;</span> + <span class="keyword">this</span>.Type().ToString() + <span class="stringliteral">&quot;  Has Sub-FSM! Starting submachine...&quot;</span>); }</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>            <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.Start(e);</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>        }</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>            <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#afa33033805ea8cbc9b91ae2d002ffcd7">wpnDebugPrint</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a>) + <span class="stringliteral">&quot; { &quot;</span> + <span class="keyword">this</span>.Type().ToString()); }</div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>    }</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span> </div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a9f39d4df2ec979d1e8c116d159a4188a">  119</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a9f39d4df2ec979d1e8c116d159a4188a">OnUpdate</a> (<span class="keywordtype">float</span> dt)</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>    {</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a3a7c890c185e21f88cad7981bd237bbf">HasFSM</a>() &amp;&amp; <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.IsRunning())</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>            <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.GetCurrentState().OnUpdate(dt);</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>    }</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span> </div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a194033270e2a676a1090627189ab7b01">  129</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a194033270e2a676a1090627189ab7b01">OnAbort</a> (<a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e)</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>    {</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a3a7c890c185e21f88cad7981bd237bbf">HasFSM</a>() &amp;&amp; <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.IsRunning())</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>        {</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>            <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#afa33033805ea8cbc9b91ae2d002ffcd7">wpnDebugPrint</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a>) + <span class="stringliteral">&quot; OnAbort &quot;</span> + <span class="keyword">this</span>.Type().ToString() + <span class="stringliteral">&quot;  Has Sub-FSM! Aborting submachine...&quot;</span>); }</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>            <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.Abort(e);</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>        }</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>        <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#afa33033805ea8cbc9b91ae2d002ffcd7">wpnDebugPrint</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a>) + <span class="stringliteral">&quot; } ABORTED &quot;</span> + <span class="keyword">this</span>.Type().ToString()); }</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>    }</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span> </div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a30f4f41c9676d0cff249b39c5f39eb28">  143</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a30f4f41c9676d0cff249b39c5f39eb28">OnExit</a> (<a class="code hl_class" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e)</div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>    {</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>        <span class="keywordflow">if</span> (<a class="code hl_class" href="../../d9/df7/class_log_manager.html">LogManager</a>.<a class="code hl_function" href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">IsWeaponLogEnable</a>()) { <a class="code hl_function" href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#afa33033805ea8cbc9b91ae2d002ffcd7">wpnDebugPrint</a>(<span class="stringliteral">&quot;[wpnfsm] &quot;</span> + <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a>.GetDebugName(<a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">m_weapon</a>) + <span class="stringliteral">&quot; } &quot;</span> + <span class="keyword">this</span>.Type().ToString()); }</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>    }</div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span> </div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a5644aa0864aaf3cee1f2ae8011a4759d">  152</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a5644aa0864aaf3cee1f2ae8011a4759d">IsWaitingForActionFinish</a> () { <span class="keywordflow">return</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a3a7c890c185e21f88cad7981bd237bbf">HasFSM</a>() &amp;&amp; <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.IsRunning() &amp;&amp; <a class="code hl_variable" href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">m_fsm</a>.GetCurrentState().IsWaitingForActionFinish(); }</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span> </div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a2c0638897b587a6c5b068ed02baf0ce6">  158</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a2c0638897b587a6c5b068ed02baf0ce6">IsIdle</a> () { <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>    </div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#ab5b508471d08a9af91cfab3de51ae515">  163</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#ab5b508471d08a9af91cfab3de51ae515">IsBoltOpen</a> () { <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span> </div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#acd2a1f063674a50d5f8ed687f49a8593">  170</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#acd2a1f063674a50d5f8ed687f49a8593">OnSubMachineChanged</a> (<a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> src, <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> dst) { }</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span> </div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno"><a class="line" href="../../d2/db4/class_weapon_state_base.html#a15bc0ec54808d65391206b675f39e143">  177</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d2/db4/class_weapon_state_base.html#a15bc0ec54808d65391206b675f39e143">OnStateChanged</a> (<a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> src, <a class="code hl_class" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> dst) { }</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>};</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span> </div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span> </div>
<div class="ttc" id="a4___world_2_entities_2_firearms_2_debug_8c_html_acea538bf7a4dc05b05c22218a83bee44"><div class="ttname"><a href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#acea538bf7a4dc05b05c22218a83bee44">wpnDebugSpam</a></div><div class="ttdeci">void wpnDebugSpam(string s)</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c_source.html#l00017">Debug.c:17</a></div></div>
<div class="ttc" id="a4___world_2_entities_2_firearms_2_debug_8c_html_afa33033805ea8cbc9b91ae2d002ffcd7"><div class="ttname"><a href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c.html#afa33033805ea8cbc9b91ae2d002ffcd7">wpnDebugPrint</a></div><div class="ttdeci">void wpnDebugPrint(string s)</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/d1d/4___world_2_entities_2_firearms_2_debug_8c_source.html#l00009">Debug.c:9</a></div></div>
<div class="ttc" id="a_weapon___base_8c_html_aad9c748f817f5536f4f2bfd213b4afc1"><div class="ttname"><a href="../../de/df2/_weapon___base_8c.html#aad9c748f817f5536f4f2bfd213b4afc1">WeaponTransition</a></div><div class="ttdeci">enum FSMTransition WeaponTransition</div></div>
<div class="ttc" id="aclass_log_manager_html"><div class="ttname"><a href="../../d9/df7/class_log_manager.html">LogManager</a></div><div class="ttdef"><b>Definition:</b> <a href="../../de/d4c/3___game_2tools_2_debug_8c_source.html#l00542">Debug.c:543</a></div></div>
<div class="ttc" id="aclass_log_manager_html_a1936dba0ee4da1a581859d6603178326"><div class="ttname"><a href="../../d9/df7/class_log_manager.html#a1936dba0ee4da1a581859d6603178326">LogManager::IsWeaponLogEnable</a></div><div class="ttdeci">static bool IsWeaponLogEnable()</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d4c/3___game_2tools_2_debug_8c_source.html#l00628">Debug.c:628</a></div></div>
<div class="ttc" id="aclass_object_html"><div class="ttname"><a href="../../d8/d83/class_object.html">Object</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d7/d68/_object_typed_8c_source.html#l00001">ObjectTyped.c:2</a></div></div>
<div class="ttc" id="aclass_serializer_html"><div class="ttname"><a href="../../d0/dc2/class_serializer.html">Serializer</a></div><div class="ttdoc">Serialization general interface. Serializer API works with:</div><div class="ttdef"><b>Definition:</b> <a href="../../da/dc7/_serializer_8c_source.html#l00055">Serializer.c:56</a></div></div>
<div class="ttc" id="aclass_weapon___base_html"><div class="ttname"><a href="../../d3/d9c/class_weapon___base.html">Weapon_Base</a></div><div class="ttdoc">shorthand</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d62/_bolt_action_rifle___base_8c_source.html#l00005">BoltActionRifle_Base.c:6</a></div></div>
<div class="ttc" id="aclass_weapon_event_base_html"><div class="ttname"><a href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a></div><div class="ttdoc">signalize mechanism manipulation</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/dea/_events_8c_source.html#l00034">Events.c:35</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a></div><div class="ttdoc">represent weapon state base</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/da2/_bullet_hide_8c_source.html#l00001">BulletHide.c:2</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a00cd223c25fd599bd32da48bbbb40eac"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a00cd223c25fd599bd32da48bbbb40eac">WeaponStateBase::SaveCurrentFSMState</a></div><div class="ttdeci">bool SaveCurrentFSMState(ParamsWriteContext ctx)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00034">WeaponStateBase.c:34</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a033f970fce594c972f001f982a5c153f"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a033f970fce594c972f001f982a5c153f">WeaponStateBase::ProcessEvent</a></div><div class="ttdeci">bool ProcessEvent(WeaponEventBase e)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00080">WeaponStateBase.c:80</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a15bc0ec54808d65391206b675f39e143"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a15bc0ec54808d65391206b675f39e143">WeaponStateBase::OnStateChanged</a></div><div class="ttdeci">void OnStateChanged(WeaponStateBase src, WeaponStateBase dst)</div><div class="ttdoc">called on current state when state machine has changed its state</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00177">WeaponStateBase.c:177</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a194033270e2a676a1090627189ab7b01"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a194033270e2a676a1090627189ab7b01">WeaponStateBase::OnAbort</a></div><div class="ttdeci">void OnAbort(WeaponEventBase e)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00129">WeaponStateBase.c:129</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a21817665ec759d08ee0c575ba325fd79"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a21817665ec759d08ee0c575ba325fd79">WeaponStateBase::GetFSM</a></div><div class="ttdeci">WeaponFSM GetFSM()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00029">WeaponStateBase.c:29</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a2c0638897b587a6c5b068ed02baf0ce6"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a2c0638897b587a6c5b068ed02baf0ce6">WeaponStateBase::IsIdle</a></div><div class="ttdeci">bool IsIdle()</div><div class="ttdoc">idle state does not expect any animation events</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00158">WeaponStateBase.c:158</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a30f4f41c9676d0cff249b39c5f39eb28"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a30f4f41c9676d0cff249b39c5f39eb28">WeaponStateBase::OnExit</a></div><div class="ttdeci">void OnExit(WeaponEventBase e)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00143">WeaponStateBase.c:143</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a3a7c890c185e21f88cad7981bd237bbf"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a3a7c890c185e21f88cad7981bd237bbf">WeaponStateBase::HasFSM</a></div><div class="ttdeci">bool HasFSM()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00028">WeaponStateBase.c:28</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a3d9777a692f1e7eed3fe85701530a0f6"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a3d9777a692f1e7eed3fe85701530a0f6">WeaponStateBase::WeaponStateBase</a></div><div class="ttdeci">void WeaponStateBase(Weapon_Base w=NULL, WeaponStateBase parent=NULL)</div><div class="ttdoc">internal state id used for load/restore</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00017">WeaponStateBase.c:17</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a4ece586a64173d7526e0c4997d97f214"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a4ece586a64173d7526e0c4997d97f214">WeaponStateBase::GetInternalStateID</a></div><div class="ttdeci">int GetInternalStateID()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00032">WeaponStateBase.c:32</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a5644aa0864aaf3cee1f2ae8011a4759d"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a5644aa0864aaf3cee1f2ae8011a4759d">WeaponStateBase::IsWaitingForActionFinish</a></div><div class="ttdeci">bool IsWaitingForActionFinish()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00152">WeaponStateBase.c:152</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a5c32e0d708fb55e89cf3d5c8467b8171"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a5c32e0d708fb55e89cf3d5c8467b8171">WeaponStateBase::m_parentState</a></div><div class="ttdeci">WeaponStateBase m_parentState</div><div class="ttdoc">weapon that this state relates to</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00013">WeaponStateBase.c:13</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a5db3e9a07c531a470a5b80bca596c3e8"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a5db3e9a07c531a470a5b80bca596c3e8">WeaponStateBase::LoadCurrentFSMState</a></div><div class="ttdeci">bool LoadCurrentFSMState(ParamsReadContext ctx, int version)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00054">WeaponStateBase.c:54</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a61244309e09ddb8549c33adc6ba0aecf"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a61244309e09ddb8549c33adc6ba0aecf">WeaponStateBase::m_fsm</a></div><div class="ttdeci">ref WeaponFSM m_fsm</div><div class="ttdoc">hierarchical parent state of this state (or null)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00014">WeaponStateBase.c:14</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a887021c86a250f2c49eeb5dace1f61fe"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a887021c86a250f2c49eeb5dace1f61fe">WeaponStateBase::m_weapon</a></div><div class="ttdeci">Weapon_Base m_weapon</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00012">WeaponStateBase.c:12</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a989ec0b0f612e282fc36b006dd2eb9a4"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a989ec0b0f612e282fc36b006dd2eb9a4">WeaponStateBase::SetParentState</a></div><div class="ttdeci">void SetParentState(WeaponStateBase parent)</div><div class="ttdoc">allows construction of hierarchical state machine</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00022">WeaponStateBase.c:22</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_a9f39d4df2ec979d1e8c116d159a4188a"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#a9f39d4df2ec979d1e8c116d159a4188a">WeaponStateBase::OnUpdate</a></div><div class="ttdeci">void OnUpdate(float dt)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00119">WeaponStateBase.c:119</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_ab5b508471d08a9af91cfab3de51ae515"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#ab5b508471d08a9af91cfab3de51ae515">WeaponStateBase::IsBoltOpen</a></div><div class="ttdeci">bool IsBoltOpen()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00163">WeaponStateBase.c:163</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_abb1ef39a577289abdc0dcd6f422873fe"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#abb1ef39a577289abdc0dcd6f422873fe">WeaponStateBase::GetParentState</a></div><div class="ttdeci">WeaponStateBase GetParentState()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00026">WeaponStateBase.c:26</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_abf96f46d474286b755b35c5d6e7f1a5d"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#abf96f46d474286b755b35c5d6e7f1a5d">WeaponStateBase::m_InternalID</a></div><div class="ttdeci">int m_InternalID</div><div class="ttdoc">nested state machine (or null)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00015">WeaponStateBase.c:15</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_acd2a1f063674a50d5f8ed687f49a8593"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#acd2a1f063674a50d5f8ed687f49a8593">WeaponStateBase::OnSubMachineChanged</a></div><div class="ttdeci">void OnSubMachineChanged(WeaponStateBase src, WeaponStateBase dst)</div><div class="ttdoc">called when sub-machine has changed its state</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00170">WeaponStateBase.c:170</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_acf59c5609264e2cfc2eaed43bb116a53"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#acf59c5609264e2cfc2eaed43bb116a53">WeaponStateBase::SetInternalStateID</a></div><div class="ttdeci">void SetInternalStateID(int i)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00031">WeaponStateBase.c:31</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_ad21398c2a10afb8fae352b527bdbd9f3"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#ad21398c2a10afb8fae352b527bdbd9f3">WeaponStateBase::AddTransition</a></div><div class="ttdeci">void AddTransition(WeaponTransition t)</div><div class="ttdoc">adds transition into m_fsm transition table</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00089">WeaponStateBase.c:89</a></div></div>
<div class="ttc" id="aclass_weapon_state_base_html_af630f354d30ca508c6d778a91b841098"><div class="ttname"><a href="../../d2/db4/class_weapon_state_base.html#af630f354d30ca508c6d778a91b841098">WeaponStateBase::OnEntry</a></div><div class="ttdeci">void OnEntry(WeaponEventBase e)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d28/_weapon_state_base_8c_source.html#l00103">WeaponStateBase.c:103</a></div></div>
<div class="ttc" id="agroup___debug_html_ga786b160dafbe15abb829786ba345cb15"><div class="ttname"><a href="../../d0/d62/group___debug.html#ga786b160dafbe15abb829786ba345cb15">Error</a></div><div class="ttdeci">void Error(string err)</div><div class="ttdoc">Messagebox with error message.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d19/_en_debug_8c_source.html#l00090">EnDebug.c:90</a></div></div>
<div class="ttc" id="anamespace_3global_scope_4_html_dc/d73/class_weapon_f_s_m"><div class="ttname"><a href="../../d0/deb/namespace_3global_scope_4.html#dc/d73/class_weapon_f_s_m">WeaponFSM</a></div><div class="ttdoc">weapon finite state machine</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_dc42280174b209627d8212c9e40d7e50.html">scripts</a></li><li class="navelem"><a class="el" href="../../dir_2e5c1ab951ac691cd4fc8c5e713c6c8a.html">4_World</a></li><li class="navelem"><a class="el" href="../../dir_d92b8e0605e989b70f343f78d41d5ad9.html">Entities</a></li><li class="navelem"><a class="el" href="../../dir_76b70e186f3f0441d93c60d5e78b0414.html">Firearms</a></li><li class="navelem"><a class="el" href="../../dir_372752df6a93f8a8dc049f875df777d6.html">FSM</a></li><li class="navelem"><a class="el" href="../../dir_22eec264e034c1217c0d1740cfb655ec.html">States</a></li><li class="navelem"><a class="el" href="../../d3/d28/_weapon_state_base_8c.html">WeaponStateBase.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
